//
//  BocaBTController.h
//  BocaLibTester
//
//  Created by michael hall on 9/13/16.
//  Copyright © 2016 Boca Systems. All rights reserved.
//
//

#import <Foundation/Foundation.h>
#import <ExternalAccessory/ExternalAccessory.h>

@class AccessoryVC;

@interface EAController : NSObject <EAAccessoryDelegate, NSStreamDelegate>
{
    NSMutableArray *_accessoryList;
    EAAccessory *_selectedAccessory;
    EASession *_session;
    NSString *_protocolString;
    NSMutableData *_writeDataBuffer;
    AccessoryVC __unsafe_unretained *_accessoryVC;
}

@property (nonatomic, retain, readonly) EAAccessory *selectedAccessory;
@property (nonatomic, copy) NSString *protocolString;
@property (retain) NSMutableData *writeDataBuffer;
@property (nonatomic, unsafe_unretained) AccessoryVC *accessoryVC;

+ (EAController *)sharedController;

- (void)setupControllerForAccessory:(EAAccessory *)accessory withProtocolString:(NSString *)protocolString;

- (BOOL)openSession;
- (BOOL)openSessionPicker;
- (void)closeSession;

- (void)writeData:(NSData *)data;

- (BOOL)isAccessoryConnected;

// from EAAccessoryDelegate
- (void)accessoryDidDisconnect:(EAAccessory *)accessory;

// from EAAccessory notifications
- (void)accessoryConnected:(NSNotification *)notification;
- (void)accessoryDisconnected:(NSNotification *)notification;


@end

extern BOOL Open_BT(void);
extern BOOL Open_BTPicker(NSString *name);
extern void Close_BT(void);
extern void Write_BT(NSString *string);
extern void Write_BT_Data(uint8_t *buf, int bufLen);
extern NSString *Read_BT(void);
extern void ClearStatus_BT(void);









