///////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  BocaUSBController.h
//  BocaIpadSDK
//
//  Created by Michael Hall on 11/16/17.
//  Copyright © 2017 Boca Systems. All rights reserved.
//
///////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef BocaUSBController_h
#define BocaUSBController_h


#endif /* BocaUSBController_h */
#import <Foundation/Foundation.h>
#import <ExternalAccessory/ExternalAccessory.h>

@class AccessoryVC;

@interface EAControllerUSB : NSObject <EAAccessoryDelegate, NSStreamDelegate>
{
    NSMutableArray *_accessoryList;
    EAAccessory *_selectedAccessory;
    EASession *_session;
    NSString *_protocolString;
    NSMutableData *_writeDataBuffer;
    AccessoryVC __unsafe_unretained *_accessoryVC;
}

@property (nonatomic, retain, readonly) EAAccessory *selectedAccessory;
@property (nonatomic, copy) NSString *protocolString;
@property (retain) NSMutableData *writeDataBuffer;
@property (nonatomic, unsafe_unretained) AccessoryVC *accessoryVC;

+ (EAControllerUSB *)sharedController;

- (void)setupControllerForAccessory:(EAAccessory *)accessory withProtocolString:(NSString *)protocolString;

- (BOOL)openSession;
- (void)closeSession;

- (void)writeData:(NSData *)data;

- (BOOL)isAccessoryConnected;

// from EAAccessoryDelegate
- (void)accessoryDidDisconnect:(EAAccessory *)accessory;

// from EAAccessory notifications
- (void)accessoryConnected:(NSNotification *)notification;
- (void)accessoryDisconnected:(NSNotification *)notification;


@end

extern BOOL Open_USB(void);
extern void Close_USB(void);
extern void Write_USB(NSString *string);
extern void Write_USB_Data(uint8_t *buf, int bufLen);
extern NSString *Read_USB(void);
extern void ClearStatus_USB(void);


