//
//  BocaWFController.m
//  BocaIpadSDK
//
//  Created by michael hall on 9/16/16.
//  Copyright © 2016 Boca Systems. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <netinet/in.h>
#include <arpa/inet.h>                  //inet_addr
#import "BocaWFController.h"

void WFReturnStatus(void);

//Wi-Fi
CFWriteStreamRef myWriteStream = NULL;
CFReadStreamRef myReadStream = NULL;
CFSocketNativeHandle sock;
CFSocketRef TCPClient;

CFDataRef df;
BOOL ValidateConnection(NSString *ipAddress, int port, double seconds);
void ConnectCallBack(CFSocketRef socket, CFSocketCallBackType type, CFDataRef address, const void *data, void *info);
extern NSString *s;

BOOL Open_WF(NSString *ip)
{
    UInt32 port = 9100;
    CFStringRef host = (__bridge CFStringRef)ip;
    BOOL status = false;
    //connectionStatus = false;               //initialize return negative status
    
    //NSLog(@"Open WiFi");
    
    //if(connectionStatus == false)
    //{
        
        status = ValidateConnection(ip, port, 5);
        if(status)
        {
            CFStreamCreatePairWithSocketToHost(kCFAllocatorDefault, host, port, &myReadStream, &myWriteStream);
            CFWriteStreamSetProperty(myWriteStream, kCFStreamPropertyShouldCloseNativeSocket, kCFBooleanTrue);
            
            //open write channel to printer
            CFWriteStreamOpen(myWriteStream);
            
            if(myWriteStream != NULL)
            {
                //open read channel from printer
                CFReadStreamOpen(myReadStream);
                
                //Mode = @"WF";                           //set mode to WiFi
                status = true;                //return positive status
            }
            else
                status = false;
            
        }
        //else
        //{
            
        //}
    //}
    return(status);
}

void Close_WF()
{
    //NSLog(@"Close WiFi");
    //V6.3 Beta added NULL tests here and below.  CFRelease periodically crashes when passed a NULL value
    if(myWriteStream != NULL)
    {
        CFWriteStreamClose(myWriteStream);
        CFRelease(myWriteStream);
        myWriteStream = NULL;
    }
    
    //V6.3 Beta added NULL tests here and below.  CFRelease periodically crashes when passed a NULL value
    if(myReadStream != NULL)
    {
        CFReadStreamClose(myReadStream);
        CFRelease(myReadStream);
        myReadStream = NULL;
    }
}

void Write_WF(NSString *string)
{
    NSData* command=[string dataUsingEncoding:NSUTF8StringEncoding];
    
    const uint8_t *buf = (const uint8_t*)[command bytes];
    CFIndex bufLen = command.length;
    CFWriteStreamWrite(myWriteStream, buf, bufLen);
}

void Write_WF_Data(uint8_t *buf, int bufLen)
{
    CFWriteStreamWrite(myWriteStream, buf, bufLen);
}

NSString *Read_WF()
{
    WFReturnStatus();
    return(s);
}

void ClearStatus_WF()
{
    s = @"";
}

#define EAD_INPUT_BUFFER_SIZE 128
void WFReturnStatus()
{
    //NSLog(@"EAController::WFReturnStatus");
    uint bytesAppended=0;
    uint bytesProcessed=0;
    uint8_t buf[EAD_INPUT_BUFFER_SIZE];
    NSString * Status=@"";
    while (CFReadStreamHasBytesAvailable(myReadStream))
    {
        NSInteger bytesRead = CFReadStreamRead(myReadStream, buf, EAD_INPUT_BUFFER_SIZE);
        //NSLog(@"read %ld bytes from input stream", (long)bytesRead);
        
        while(bytesProcessed < bytesRead)
        {
            if(buf[bytesAppended] < 32)                      //if non-printable character, look at as status
            {
                switch (buf[bytesAppended])                  //check for most common status
                {
                    case 0x6:
                        Status = @"Ticket ACK";
                        break;
                    case 0x8:
                        Status = @"Invalid Checksum";
                        break;
                    case 0x9:
                        Status = @"Valid Checksum";
                        break;
                    case 0x10:
                        Status = @"Out of Tickets";
                        break;
                    case 0x11:
                        Status = @"X-On";
                        break;
                    case 0x12:
                        Status = @"Power On";
                        break;
                    case 0x13:
                        Status = @"X-Off";
                        break;
                    case 0x15:
                        Status = @"Ticket NAK";
                        break;
                    case 0x18:
                        Status = @"Ticket Jam";
                        break;
                    case 0x1D:
                        Status = @"Cutter Jam";
                        break;
                    default:
                        Status = @"";
                        //Status = [NSString stringWithFormat:@"%@%d",@"Non Standard Status Value = ",buf[bytesAppended]];
                        break;
                }
                bytesAppended++;
                bytesProcessed++;
                //NSLog(@"A Status = %@",Status);
            }
            else                                             //printable character
            {
                Status = [[NSString alloc] initWithBytes:buf length:(NSUInteger)bytesRead encoding:NSUTF8StringEncoding];
                bytesProcessed += bytesRead;                 //@mdh
                bytesAppended += bytesRead;                  //@mdh
                //NSLog(@"B Status = %@",Status);
            }
            
            //Concatenate return status into buffer, waiting to return to parent application
            s = [NSString stringWithFormat:@"%@%@\n",s,Status];
            
        }
    }
}

BOOL ValidateConnection(NSString *ipAddress, int port, double seconds)
{

    //NSLog(@"ValidateConnection");
    @try
    {
 
        char print[] = "print";
        // Build our socket context; this ties the joke to the socket
        CFSocketContext CTX = { 0, print, NULL, NULL, NULL };
 
        //We just need a TCP socket. Nothing fancy.
        //save original socket = CFSocketCreate(kCFAllocatorDefault,PF_INET,SOCK_STREAM,IPPROTO_TCP,0,NULL,NULL);
 
        //setup TCP client using ConnectCallBack to handle events
        TCPClient = CFSocketCreate(NULL,PF_INET,SOCK_STREAM,IPPROTO_TCP,kCFSocketConnectCallBack | kCFSocketDataCallBack, (CFSocketCallBack)ConnectCallBack, &CTX);
 
        // kCFSocketReadCallBack = 1,
        // kCFSocketAcceptCallBack = 2,
        // kCFSocketDataCallBack = 3,
        // kCFSocketConnectCallBack = 4,
        // kCFSocketWriteCallBack = 8
        // TCPClient = CFSocketCreate(NULL, PF_INET, SOCK_STREAM, IPPROTO_TCP, kCFSocketConnectCallBack | kCFSocketDataCallBack | kCFSocketReadCallBack | kCFSocketWriteCallBack |kCFSocketAcceptCallBack, (CFSocketCallBack)ConnectCallBack, &CTX);
        struct sockaddr_in sin;
 
        memset(&sin, 0, sizeof(sin));
        sin.sin_len = sizeof(sin);
        sin.sin_family = AF_INET;
        sin.sin_port = htons(port); // port we want to connect on
        sin.sin_addr.s_addr = inet_addr([ipAddress UTF8String]);
 
        CFDataRef address = CFDataCreate(NULL,(unsigned char*)&sin,sizeof(sin));
 
        CFTimeInterval timeout = seconds ; // how long to wait before returning
 
        CFSocketError err = CFSocketConnectToAddress(TCPClient,address,timeout);
        //CFSocketError err = CFSocketConnectToAddress(TCPClient,address,-1);
 
        //in future development this code may be used to start a read thread.  For now clicking the
        //read status button will perform the read.  //Auto Read
        //CFRunLoopSourceRef sourceRef = CFSocketCreateRunLoopSource(kCFAllocatorDefault, TCPClient, 0);
        //CFRunLoopAddSource(CFRunLoopGetCurrent(), sourceRef, kCFRunLoopCommonModes);
        //CFRelease(sourceRef);
        //CFRunLoopRun();
 
        //manual read
        CFSocketInvalidate(TCPClient) ;
        
        //V6.3 Beta added NULL tests here and below.  CFRelease periodically crashes when passed a NULL value
        if(address != NULL)
            CFRelease(address);
        
        //V6.3 Beta added NULL tests here and below.  CFRelease periodically crashes when passed a NULL value
        if(TCPClient != NULL)
            CFRelease(TCPClient);
 
        return(err == 0) ;
 
    }
    @catch (id SocketException)
    {
        return(false) ;
    }
}
 
void ConnectCallBack(CFSocketRef socket, CFSocketCallBackType type, CFDataRef address, const void *data, void *info)
{
    //NSLog(@"ConnectCallBack");
    
    //When using CFRunLoopRun above this routine comes alive
    //Does Arrives here upon connection
    if (type == kCFSocketConnectCallBack)
    {
        
        // The native socket, used for various operations
        
        sock = CFSocketGetNative(socket);
        //connectionStatus = TRUE;
        
    }
    else if(type == kCFSocketDataCallBack)      //should arrive here when data's available but does not, hence the manual read button/code
    {
        
        df = (CFDataRef)data;
        long len = CFDataGetLength(df);
        if (len > 0)
        {
            
            CFRange range = CFRangeMake(0, len);
            UInt8 buffer[len];
            CFDataGetBytes(df, range, buffer);
            //NSLog(@"Data Received as string: %s\n", buffer);
            //NSLog(@"As UInt8 coding: %@", df);
            
        }
        
    }
}

















